"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
import httpx
from typing import List, Optional
from typing_extensions import Annotated, NotRequired, TypedDict
from unified_python_sdk.models.shared import atscandidate as shared_atscandidate
from unified_python_sdk.types import BaseModel
from unified_python_sdk.utils import (
    FieldMetadata,
    PathParamMetadata,
    QueryParamMetadata,
    RequestMetadata,
)


class PatchAtsCandidateRequestTypedDict(TypedDict):
    ats_candidate: shared_atscandidate.AtsCandidateTypedDict
    connection_id: str
    r"""ID of the connection"""
    id: str
    r"""ID of the Candidate"""
    fields: NotRequired[List[str]]
    r"""Comma-delimited fields to return"""


class PatchAtsCandidateRequest(BaseModel):
    ats_candidate: Annotated[
        shared_atscandidate.AtsCandidate,
        FieldMetadata(request=RequestMetadata(media_type="application/json")),
    ]

    connection_id: Annotated[
        str, FieldMetadata(path=PathParamMetadata(style="simple", explode=False))
    ]
    r"""ID of the connection"""

    id: Annotated[
        str, FieldMetadata(path=PathParamMetadata(style="simple", explode=False))
    ]
    r"""ID of the Candidate"""

    fields: Annotated[
        Optional[List[str]],
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = None
    r"""Comma-delimited fields to return"""


class PatchAtsCandidateResponseTypedDict(TypedDict):
    content_type: str
    r"""HTTP response content type for this operation"""
    status_code: int
    r"""HTTP response status code for this operation"""
    raw_response: httpx.Response
    r"""Raw HTTP response; suitable for custom response parsing"""
    ats_candidate: NotRequired[shared_atscandidate.AtsCandidateTypedDict]
    r"""Successful"""


class PatchAtsCandidateResponse(BaseModel):
    content_type: str
    r"""HTTP response content type for this operation"""

    status_code: int
    r"""HTTP response status code for this operation"""

    raw_response: httpx.Response
    r"""Raw HTTP response; suitable for custom response parsing"""

    ats_candidate: Optional[shared_atscandidate.AtsCandidate] = None
    r"""Successful"""
